require("defines")

script.on_event(defines.events.on_player_created, function(event)
	local surface = game.get_surface(1)
	local player = game.players[event.player_index]
	local x = game.player.position.x
	local y = game.player.position.y
	surface.create_entity{name="quest-delivery-system", position={x+1, y+1}, force=game.forces.player}
	game.player.gui.top.add{type="button", name="open_quest_info", caption="Quests"}
	current_quest={}
	current_quest[game.player.index]="nothing"
	selected_quest={}
	selected_quest[game.player.index]="nothing"
	
	QDS_positions = {}
	QDS_positions[game.player.index]={}
end)

script.on_event(defines.events.on_gui_click, function(event)

		-- makes things easier
	local gui_name = event.element.name
	local player = game.players[event.player_index]

	if gui_name == "open_quest_info" then	--opens main
		game.player.gui.top.open_quest_info.destroy()
		DisplayMain()
	elseif gui_name == "close_quest_info" then	--closes main
		game.player.gui.center.quest_info.destroy()
		game.player.gui.top.add{type="button", name="open_quest_info", caption="Quests"}
	elseif gui_name == "view_quests" then	--shows questline
		game.player.gui.center.quest_info.destroy()
		DisplayQuestline()
	elseif gui_name == "return_main" then	--closes questline opens main
		game.player.gui.left.questline.destroy()
		DisplayMain()
	elseif gui_name == "quests_start" then	--closes questline opens startquests
		game.player.gui.left.questline.destroy()
		DisplayStartQuests()
	elseif gui_name == "return_questline_fromstarts" then	--closes startquests opens questline
		game.player.gui.center.starting_steps_frame.destroy()
		DisplayQuestline()
	elseif gui_name == "stone_quest" then	--closes startquest opens quest
		game.player.gui.center.starting_steps_frame.destroy()
		selected_quest[event.player_index]="stone quest(x50 stone/x15 iron ore)"
		DisplayQuest("stone_quest")
	elseif gui_name == "coal_quest" then	--closes startquest opens quest
		game.player.gui.center.starting_steps_frame.destroy()
		selected_quest[event.player_index]="coal quest(x30 coal/x1 stone furnace)"
		DisplayQuest("coal_quest")
	elseif gui_name == "burner_drill_quest" then
		game.player.gui.center.starting_steps_frame.destroy()
		selected_quest[event.player_index]="burner drills quest(x2 burner drill/x25 basic belt)"
		DisplayQuest("burner_drills_quest")
	elseif gui_name == "plates_quest" then
		game.player.gui.center.starting_steps_frame.destroy()
		selected_quest[event.player_index]="plates quest(x50 iron plate, x50 copper plate/x8 inserter)"
		DisplayQuest("plates_quest")
	elseif gui_name == "power_quest" then
		game.player.gui.center.starting_steps_frame.destroy()
		selected_quest[event.player_index]="power quest(x1 offshore pump, x7 boiler, x5 steam engine/x50 small electric pole)"
		DisplayQuest("power_quest")
	elseif gui_name == "return_start" then	--closes quest opens startquest
		game.player.gui.center.quest_frame.destroy()
		DisplayStartQuests()
	elseif gui_name == "select_quest" then	--sets current quest to selected quest
		current_quest[event.player_index]=selected_quest[event.player_index]
	elseif gui_name == "submit_quest" then
		SubmitQuest(event.player_index)
	end
end)

function DisplayMain()
	game.player.gui.center.add{type="frame", name="quest_info",direction="vertical"}
	game.player.gui.center.quest_info.add{type="label", caption = "Welcome to the Factorio Quest Mod"}
	game.player.gui.center.quest_info.add{type="button", name="view_quests", caption="Start quests"}
	game.player.gui.center.quest_info.add{type="button", name="close_quest_info", caption="Close"}
	game.player.gui.center.quest_info.add{type="label", caption=("Current quest: "..current_quest[game.player.index])}
	game.player.gui.center.quest_info.add{type="button",name="submit_quest",caption="Submit quest"}
end

function DisplayQuestline()
	game.player.gui.left.add{type="frame", name="questline", direction="vertical"}
	game.player.gui.left.questline.add{type="label", caption="Choose a quest:"}
	game.player.gui.left.questline.add{type="button", name="quests_start", caption="Starting Steps"}
	game.player.gui.left.questline.add{type="button", name="quests_step", caption="One small step.."}
	game.player.gui.left.questline.add{type="button", name="quests_revolution", caption="Revolution!"}
	game.player.gui.left.questline.add{type="button", name="return_main", caption="Back"}
end

function DisplayStartQuests()
	game.player.gui.center.add{type="frame",name="starting_steps_frame", direction="horizontal"}
	game.player.gui.center.starting_steps_frame.add{type="button",name="stone_quest", caption="Stone cold"}
	game.player.gui.center.starting_steps_frame.add{type="button",name="coal_quest",caption="Coal dust"}
	game.player.gui.center.starting_steps_frame.add{type="button",name="burner_drill_quest",caption="Burning drills"}
	game.player.gui.center.starting_steps_frame.add{type="button",name="plates_quest",caption="Plates"}
	game.player.gui.center.starting_steps_frame.add{type="button",name="power_quest",caption="Man Power"}
	game.player.gui.center.starting_steps_frame.add{type="button", name="return_questline_fromstarts", caption="Back"}
end

function DisplayQuest(QuestName)
	game.player.gui.center.add{type="frame",name="quest_frame",direction="vertical"}
	game.player.gui.center.quest_frame.add{type="button",name="return_start", caption="Back"}
	if QuestName == "stone_quest" then
		game.player.gui.center.quest_frame.add{type="label",caption="Requirements: stone x50"}
		game.player.gui.center.quest_frame.add{type="label",caption="Rewards: iron ore x15"}
	elseif QuestName == "coal_quest" then
		game.player.gui.center.quest_frame.add{type="label",caption="Requirements: coal x30"}
		game.player.gui.center.quest_frame.add{type="label",caption="Rewards: stone furnace x1"}
	elseif QuestName == "burner_drills_quest" then
		game.player.gui.center.quest_frame.add{type="label",caption="Requirements: burner mining drill x2"}
		game.player.gui.center.quest_frame.add{type="label",caption="Rewards: basic transport belt x25"}
	elseif QuestName == "plates_quest" then
		game.player.gui.center.quest_frame.add{type="label",caption="Requirements: iron plate x50, copper plate x50"}
		game.player.gui.center.quest_frame.add{type="label",caption="Rewards: basic inserter x8"}
	elseif QuestName == "power_quest" then
		game.player.gui.center.quest_frame.add{type="label",caption="Requirements: offshore pump x1, boiler x7, steam engine x5"}
	end
	game.player.gui.center.quest_frame.add{type="button",name="select_quest",caption="Select"}
end

script.on_event(defines.events.on_built_entity, function(event)
	local entity = event.created_entity
	local player = game.players[event.player_index]
	local x = entity.position.x
	local y = entity.position.y
	
	if entity.name == "quest-delivery-system" then
		QDS_positions[event.player_index]["x"] = x
		QDS_positions[event.player_index]["y"] = y
		player.print(QDS_positions[event.player_index]["x"])
		player.print(QDS_positions[event.player_index]["y"])
	end

end)

function SubmitQuest(PlayerIndex)
	local player = game.players[PlayerIndex]
	local reward_type = GetQuestRewards(current_quest[PlayerIndex])["type"][1]
	local reward_count = GetQuestRewards(current_quest[PlayerIndex])["count"][1]
	if CheckQuestComplete(PlayerIndex) == "true" then
		game.player.insert{name= reward_type, count = reward_count}
		game.player.print("Quest complete! Recieved "..reward_type.." x"..reward_count)
	else
		game.player.print("not enough resources!")
	end	
end

function CheckQuestComplete(PlayerIndex)
	local complete = false
	local player = game.players[PlayerIndex]
	local x = QDS_positions[PlayerIndex]["x"]
	local y = QDS_positions[PlayerIndex]["y"]
	local entity = game.player.surface.find_entity("quest-delivery-system",{x,y})
	local requirements = {}
	requirements["type"]={}
	requirements["count"]={}
	for i = 1, GetNoOfRequirements(current_quest[PlayerIndex]) do
		requirements["type"][i] = GetQuestRequirements(current_quest[PlayerIndex])["type"][i]
		requirements["count"][i] = GetQuestRequirements(current_quest[PlayerIndex])["count"][i]
	end
	
	for i = 1, GetNoOfRequirements(current_quest[PlayerIndex]) do
		if entity.get_item_count(requirements["type"][i]) >= requirements["count"][i] then
			complete = "true"
			entity.remove_item{name=requirements["type"][i],count=requirements["count"][i]}
		end
	end
	return complete
end

function GetQuestRequirements(QuestName)
	local requirements={}
	requirements["type"]={}
	requirements["count"]={}
	if QuestName == "stone quest(x50 stone/x15 iron ore)" then
		requirements["type"][1] = "stone"
		requirements["count"][1] = 50
	elseif QuestName == "coal quest(x30 coal/x1 stone furnace)" then
		requirements["type"][1] = "coal"
		requirements["count"][1] = 30
	elseif QuestName == "burner drills quest(x2 burner drill/x25 basic belt)" then
		requirements["type"][1] = "burner-mining-drill"
		requirements["count"][1] = 2
	elseif QuestName == "plates quest(x50 iron plate, x50 copper plate/x8 inserter)" then
		requirements["type"][1] = "iron-plate"
		requirements["type"][2] = "copper-plate"
		requirements["count"][1] = 50
		requirements["count"][2] = 50
	elseif QuestName == "power quest(x1 offshore pump, x7 boiler, x5 steam engine/x50 small electric pole)" then
		requirements["type"][1] = "offshore-pump"
		requirements["type"][2] = "boiler"
		requirements["type"][3] = "steam-engine"
		requirements["count"][1] = 1
		requirements["count"][2] = 7
		requirements["count"][3] = 5
	end
	return requirements
end

function GetNoOfRequirements(QuestName)
	local number = 0
	if QuestName == "stone quest(x50 stone/x15 iron ore)" then
		number = 1
	elseif QuestName == "coal quest(x30 coal/x1 stone furnace)" then
		number = 1
	elseif QuestName == "burner drills quest(x2 burner drill/x25 basic belt)" then
		number = 1
	elseif QuestName == "plates quest(x50 iron plate, x50 copper plate/x8 inserter)" then
		number = 2
	elseif QuestName == "power quest(x1 offshore pump, x7 boiler, x5 steam engine/x50 small electric pole)" then
		number = 3
	end
	return number
end

function GetQuestRewards(QuestName)
	local rewards = {}
	rewards["type"]={}
	rewards["count"]={}
	if QuestName == "stone quest(x50 stone/x15 iron ore)" then
		rewards["type"][1] = "iron-ore"
		rewards["count"][1] = 15
	elseif QuestName == "coal quest(x30 coal/x1 stone furnace)" then
		rewards["type"][1] = "stone-furnace"
		rewards["count"][1] = 1
	elseif QuestName == "burner drills quest(x2 burner drill/x25 basic belt)" then
		rewards["type"][1] = "basic-transport-belt"
		rewards["count"][1] = 25
	elseif QuestName == "plates quest(x50 iron plate, x50 copper plate/x8 inserter)" then
		rewards["type"][1] = "basic-inserter"
		rewards["count"][1] = 8
	elseif QuestName == "power quest(x1 offshore pump, x7 boiler, x5 steam engine/x50 small electric pole)" then
		rewards["type"][1] = "small-electric-pole"
		rewards["count"][1] = 50
	end
	return rewards
end

function ErrorHandler(err)	--this is useless really. it isn't called anywhere...
	game.print("Error: "..err)
end


